"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tokenizer = tokenizer;
const REGEX = /[^\s{}]/i;
function tokenizer(input) {
    let current = 0;
    const tokens = [];
    while (current < input.length) {
        let char = input[current];
        if (char === '{') {
            tokens.push({ type: 'paren', value: '{', position: current });
            current++;
            continue;
        }
        if (char === '}') {
            tokens.push({ type: 'paren', value: '}', position: current });
            current++;
            continue;
        }
        if (char === '"') {
            let value = '';
            char = input[++current];
            while (char !== '"' && char != null) {
                value += char;
                char = input[++current];
            }
            char = input[++current];
            tokens.push(...tokenizer(value));
            continue;
        }
        if (/\s/.test(char)) {
            current++;
            continue;
        }
        let text = '';
        while (REGEX.test(char) && char != null) {
            text += char;
            char = input[++current];
        }
        tokens.push({ type: 'string', value: text, position: current });
    }
    return tokens;
}
//# sourceMappingURL=tokenizer.js.map