"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformer = transformer;
const traverser_1 = require("./traverser");
function transformer(ast) {
    const newAst = {
        body: [],
        type: 'Program',
    };
    ast._context = newAst.body;
    (0, traverser_1.traverser)(ast, {
        Method: {
            enter(node, parent) {
                let expression = {
                    arguments: [],
                    callee: {
                        name: node.name,
                        type: 'Identifier',
                    },
                    end: node.end,
                    start: node.start,
                    type: 'CallExpression',
                };
                node._context = expression.arguments;
                if (parent.type !== 'Method') {
                    expression = {
                        end: node.end,
                        expression,
                        start: node.start,
                        type: 'ExpressionStatement',
                    };
                }
                parent._context.push(expression);
            },
        },
        String: {
            enter(node, parent) {
                parent._context.push({
                    type: 'String',
                    value: node.value,
                });
            },
        },
    });
    return newAst;
}
//# sourceMappingURL=transformer.js.map