import 'source-map-support/register';
import * as fetch from 'isomorphic-fetch';
import { IMessage, ISetting, ParserMethod } from './interface';
import { Middleware } from './middleware';
export { VarType } from './methods/variable';
export { IMessage, ISetting, ParserMethod } from './interface';
export interface ParserContext {
    cache: Array<string | number | boolean | string[] | number[] | object>;
    request: typeof fetch;
}
export declare class Parser {
    middleware: Middleware;
    private _methods;
    constructor(middleware?: Middleware);
    parse(message: IMessage, settings: ISetting, text: string, cache?: ParserContext['cache']): Promise<string>;
    parseWithOutContext(text: string, messageContext?: Partial<IMessage>, settingsContext?: Partial<ISetting>, cache?: ParserContext['cache']): Promise<string>;
    addMethods(methods: ParserMethod | ParserMethod[]): void;
    private run;
    private handle;
    private handleRepeat;
}
