import { ParserContext } from '../';
export interface IMessage {
    channel: {
        id: string | number;
        name: string;
        coreId?: string;
        serviceId?: string;
    };
    provider: string;
    message: {
        args: string[];
        raw: string;
    };
    user: {
        id: string | number;
        name: string;
        roles?: string[];
    };
}
export interface ISetting {
    timezone: string;
}
export type ReturnValueType = string | number | boolean | undefined;
export interface ParserMethod {
    name: string;
    method: (message: IMessage, settings: ISetting, context: ParserContext, ...args: ReturnValueType[]) => ReturnValueType | Promise<ReturnValueType>;
}
