"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.streamer = streamer;
exports.stream = stream;
exports.link = link;
exports.title = title;
exports.game = game;
exports.provider = provider;
exports.previousstatus = previousstatus;
const config = require("config");
const helpers_1 = require("../lib/helpers");
const kick_1 = require("./kick");
const picarto_1 = require("./picarto");
const trovo_1 = require("./trovo");
const twitch_1 = require("./twitch");
const providers = {
    kick: kick_1.kick,
    trovo: trovo_1.trovo,
    twitch: twitch_1.twitch,
    picarto: picarto_1.picarto,
};
function streamer(message) {
    return message.channel.name;
}
function stream(message, _settings, _context, channel = message.channel.name) {
    if (config.has(`providers.${message.provider.toLowerCase()}.urls.base`) === false) {
        return '[Error: Invalid Provider]';
    }
    return `${config.get(`providers.${message.provider.toLowerCase()}.urls.base`)}/${(0, helpers_1.removeTag)(channel)}`;
}
function link(message, _settings, _context, channel = message.channel.name) {
    return stream(message, _settings, _context, channel);
}
function title(message_1, settings_1, context_1) {
    return __awaiter(this, arguments, void 0, function* (message, settings, context, channel = message.channel.id) {
        if (providers[message.provider.toLowerCase()] === undefined) {
            return '[Error: Invalid Provider]';
        }
        return providers[message.provider.toLowerCase()].call(this, message, settings, context, 'title', channel);
    });
}
function game(message_1, settings_1, context_1) {
    return __awaiter(this, arguments, void 0, function* (message, settings, context, channel = message.channel.id) {
        if (providers[message.provider.toLowerCase()] === undefined) {
            return '[Error: Invalid Provider]';
        }
        return providers[message.provider.toLowerCase()].call(this, message, settings, context, 'game', channel);
    });
}
function provider(message) {
    return message.provider;
}
function previousstatus(message_1, _settings_1, _context_1) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, _context, type = 'title') {
        const previous = yield this.middleware.onHandleMethod('previousStatus', message);
        if (previous == null) {
            return '[Error: Unable to get previous status]';
        }
        return previous[type] || `[Error: Failed to find value for type "${type}"]`;
    });
}
//# sourceMappingURL=channel.js.map