"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.costream = costream;
const supportedProviders = [
    'twitch',
];
function costream(message_1, _settings_1, _context_1) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, _context, withLinks = 'true') {
        if (!supportedProviders.includes(message.provider.toLowerCase())) {
            return '[Error: Invalid Provider]';
        }
        let showLinks = true;
        try {
            const res = JSON.parse(withLinks);
            if (typeof res === 'boolean') {
                showLinks = res;
            }
            if (typeof res === 'number') {
                if (res === 1) {
                    showLinks = true;
                }
                if (res === 0) {
                    showLinks = true;
                }
            }
        }
        catch (_a) {
            showLinks = true;
        }
        return getData(message.provider);
    });
}
function getData(provider) {
    return __awaiter(this, void 0, void 0, function* () {
        switch (provider) {
            default:
                return '[Error: Invalid Provider]';
        }
    });
}
//# sourceMappingURL=costream.js.map