"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ctx = ctx;
const lodash_1 = require("lodash");
function ctx(_message_1, _settings_1, _a, index_1, pickOpts_1) {
    return __awaiter(this, arguments, void 0, function* (_message, _settings, { cache }, index, pickOpts) {
        if (cache == null) {
            return '';
        }
        const safeIndex = isNaN(Number(index)) ? 0 : Number(index);
        const cachedValue = cache[safeIndex];
        if (cachedValue == null) {
            return '';
        }
        if ((0, lodash_1.isArray)(cachedValue)) {
            if (pickOpts == null) {
                return '[Error: Missing pick options]';
            }
            return cachedValue[Number(pickOpts)] || '';
        }
        switch (typeof cachedValue) {
            case 'string':
            case 'number':
                return cachedValue;
            case 'object': {
                if (pickOpts == null) {
                    return '[Error: Missing pick options]';
                }
                return (0, lodash_1.get)(cachedValue, pickOpts) || '[Error: Pick option invalid]';
            }
            default:
                return '[Error: Invalid cache value]';
        }
    });
}
//# sourceMappingURL=ctx.js.map