"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.diceroll = diceroll;
const rpg_dice_roller_1 = require("@dice-roller/rpg-dice-roller");
function diceroll(_message, _settings, _context, ...roll) {
    return __awaiter(this, void 0, void 0, function* () {
        const rollInput = (roll === null || roll === void 0 ? void 0 : roll.join(' ')) || '';
        if (rollInput === '' || rollInput == null || rollInput.length < 1) {
            return '[Error: No input]';
        }
        try {
            const roller = new rpg_dice_roller_1.DiceRoll(rollInput);
            return roller === null || roller === void 0 ? void 0 : roller.output;
        }
        catch (_a) {
            return '[Error: Unable to roll dice]';
        }
    });
}
//# sourceMappingURL=diceroll.js.map