import { Parser } from '../';
import { IMessage, ISetting } from '../interface';
export interface IGlimeshRes {
    data: {
        channel: null | IGlimeshChannel;
        followers: null | IGlimeshFollow[];
    };
    errors: {
        locations: {
            column: number;
            line: number;
        }[];
        message: string;
        path: string[];
    }[];
}
export interface IGlimeshChannel {
    category: {
        name: string;
    };
    title: string;
    streamer: {
        username: string;
    };
    stream: null | IGlimeshStream;
}
export interface IGlimeshFollow {
    insertedAt: string;
}
export interface IGlimeshStream {
    startedAt: string;
}
export declare function glimesh(this: Parser, message: IMessage, _settings: ISetting, request: typeof fetch, type: string, channel?: string | number): Promise<"[Error: API Error]" | "[Error: Invalid Channel]" | "[Error: Return Value Invalid]" | "[Type Not Found]">;
