"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.glimesh = void 0;
const config = require("config");
const lodash_1 = require("lodash");
const helpers_1 = require("../lib/helpers");
function glimesh(message, _settings, request, type, channel = message.channel.id) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const reqHeaders = {
            Authorization: `Client-ID ${config.get('providers.glimesh.clientId')}`,
        };
        const reqBody = `
        query {
            channel(username: "${channel}") {
                category {
                    name
                }
                title
                streamer {
                    username
                }
            }
        }
    `;
        const req = yield (0, helpers_1.httpRequest)(request, config.get('providers.glimesh.api'), { headers: reqHeaders, method: 'POST', body: reqBody });
        if (req == null) {
            return '[Error: API Error]';
        }
        if (((_a = req === null || req === void 0 ? void 0 : req.data) === null || _a === void 0 ? void 0 : _a.channel) === null) {
            return '[Error: Invalid Channel]';
        }
        const value = (0, lodash_1.get)(req, (0, helpers_1.getFromSimple)('glimesh', type), '[Type Not Found]');
        if (!(0, helpers_1.isValueValid)(value)) {
            return '[Error: Return Value Invalid]';
        }
        return value;
    });
}
exports.glimesh = glimesh;
//# sourceMappingURL=glimesh.js.map