import { charity } from './charity';
import { costream } from './costream';
import { ctx } from './ctx';
import { currency } from './currency/currency';
import { currencyadjust } from './currency/currencyadjust';
import { currencyname } from './currency/currencyname';
import { diceroll } from './diceroll';
import { extralife } from './extralife';
import { followage } from './followage';
import { kick } from './kick';
import { lastfm } from './lastfm';
import { mastodon } from './mastodon';
import { picarto } from './picarto';
import { pretzel } from './pretzel';
import { rainwave } from './rainwave';
import { randomuser } from './randomuser';
import * as str from './string';
import { tiktok } from './tiktok';
import { time } from './time';
import { trovo } from './trovo';
import { twitch } from './twitch';
import { uptime } from './uptime';
import { urlfetch, urlfetchctx } from './urlfetch';
import { variable } from './variable';
import { weather } from './weather';
export declare const methods: {
    variable: typeof variable;
    weather: typeof weather;
    currency: typeof currency;
    currencyadjust: typeof currencyadjust;
    currencyname: typeof currencyname;
    user(message: import("..").IMessage): string;
    touser(message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, noDefault?: boolean): string;
    userid(message: import("..").IMessage): string | number;
    time: typeof time;
    trovo: typeof trovo;
    twitch: typeof twitch;
    uptime: typeof uptime;
    urlfetch: typeof urlfetch;
    urlfetchctx: typeof urlfetchctx;
    randomnum(_message: import("..").IMessage, _settings: import("..").ISetting, { cache }: import("..").ParserContext, min: string, max: string): string;
    add(_message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, ...numbers: string[]): number | "[Invalid number of arguments]" | "[No valid numbers to process]";
    arg(message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, index: string): string;
    randlist(this: import("..").Parser, _message: import("..").IMessage, _settings: import("..").ISetting, { cache }: import("..").ParserContext, ...str: string[]): Promise<string>;
    math(_message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, ...str: string[]): any;
    compile: (_message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, ...str: string[]) => string;
    query: (message: import("..").IMessage, _settings: import("..").ISetting, _ctx: import("..").ParserContext, skipIndex?: number) => string;
    echo: (message: import("..").IMessage, _settings: import("..").ISetting, _ctx: import("..").ParserContext, skipIndex?: number) => string;
    randint: typeof str.randomnum;
    incr: typeof str.add;
    urlencode: (_message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, ...str: string[]) => string;
    urldecode: (_message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, ...str: string[]) => string;
    listpick: typeof str.randlist;
    rngphrase: typeof str.randlist;
    charity: typeof charity;
    costream: typeof costream;
    diceroll: typeof diceroll;
    extralife: typeof extralife;
    followage: typeof followage;
    ctx: typeof ctx;
    kick: typeof kick;
    lastfm: typeof lastfm;
    mastodon: typeof mastodon;
    picarto: typeof picarto;
    pretzel: typeof pretzel;
    rainwave: typeof rainwave;
    randomuser: typeof randomuser;
    tiktok: typeof tiktok;
    streamer(message: import("..").IMessage): string;
    stream(message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, channel?: string): string;
    link(message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, channel?: string): string;
    title(this: import("..").Parser, message: import("..").IMessage, settings: import("..").ISetting, context: import("..").ParserContext, channel?: string | number): Promise<any>;
    game(this: import("..").Parser, message: import("..").IMessage, settings: import("..").ISetting, context: import("..").ParserContext, channel?: string | number): Promise<any>;
    provider(message: import("..").IMessage): string;
    previousstatus(this: import("..").Parser, message: import("..").IMessage, _settings: import("..").ISetting, _context: import("..").ParserContext, type?: string): Promise<any>;
};
