"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.kick = kick;
const config = require("config");
const lodash_1 = require("lodash");
const helpers_1 = require("../lib/helpers");
function kick(message_1, _settings_1, _a, type_1) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, { request }, type, channelId = message.channel.id) {
        var _b;
        const headers = {
            Accept: 'application/json',
            'Content-Type': 'application/json',
        };
        const res = yield (0, helpers_1.httpRequest)(request, `${config.get('providers.kick.urls.api')}/v1/channels/${String(channelId).toLowerCase()}`, { headers });
        if (res == null) {
            return '[Error: API Error]';
        }
        if (((_b = res === null || res === void 0 ? void 0 : res.data) === null || _b === void 0 ? void 0 : _b.channel) === null) {
            return '[Error: Invalid Channel]';
        }
        const pickValue = (0, helpers_1.getFromSimple)('kick', type);
        if (Array.isArray(pickValue)) {
            for (const value of pickValue) {
                const val = (0, lodash_1.get)(res, value, null);
                if (val == null) {
                    continue;
                }
                if ((0, helpers_1.isValueValid)(val)) {
                    return val;
                }
            }
        }
        else {
            const value = (0, lodash_1.get)(res, pickValue, '[Type Not Found]');
            if (!(0, helpers_1.isValueValid)(value)) {
                return '[Error: Return Value Invalid]';
            }
            return value;
        }
        return '[Type Not Found]';
    });
}
//# sourceMappingURL=kick.js.map