import { ParserContext } from '../';
import { IMessage, ISetting } from '../interface';
export interface IRecentTracks {
    error: number;
    recenttracks: {
        track: ITrack[];
        '@attr': {
            user: string;
            page: string;
            perPage: string;
            totalPages: string;
            total: string;
        };
    };
}
export interface ITrack {
    artist: {
        '#text': string;
        mbid: string;
    };
    name: string;
    mbid: string;
    streamable: string;
    album: {
        '#text': string;
        mbid: string;
    };
    url: string;
}
export type SongType = 'song' | 'artist' | 'link' | string;
export declare function getTrack(tracks: ITrack[], when: string): ITrack;
export declare function lastfm(_message: IMessage, _settings: ISetting, { request }: ParserContext, user: string, type?: SongType, when?: string): Promise<string>;
