"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTrack = getTrack;
exports.lastfm = lastfm;
const config = require("config");
const lodash_1 = require("lodash");
const querystring_1 = require("querystring");
const helpers_1 = require("../lib/helpers");
function getTrack(tracks, when) {
    if (isNaN(Number(when)) || Number(when) < 0 || Number(when) > 10 || tracks[Number(when)] === undefined) {
        return tracks[0];
    }
    return tracks[when];
}
function lastfm(_message_1, _settings_1, _a, user_1, type_1) {
    return __awaiter(this, arguments, void 0, function* (_message, _settings, { request }, user, type, when = '0') {
        const reqOpts = {
            api_key: config.get('parser.lastfm.key'),
            format: 'json',
            limit: 10,
            method: 'user.getrecenttracks',
            user,
        };
        const req = yield (0, helpers_1.httpRequest)(request, `${config.get('parser.lastfm.base')}?${(0, querystring_1.stringify)(reqOpts)}`);
        if (req == null || (0, lodash_1.isString)(req) || (req === null || req === void 0 ? void 0 : req.error) != null) {
            return '[Error: Invalid User]';
        }
        const { name, artist, url } = getTrack(req.recenttracks.track, when);
        switch (type) {
            case 'song':
                return name;
            case 'artist':
                return artist['#text'];
            case 'link':
                return url;
            case 'all':
                return `${name} by ${artist['#text']} (${url})`;
            default:
                return `${name} by ${artist['#text']}`;
        }
    });
}
//# sourceMappingURL=lastfm.js.map