"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.picarto = picarto;
const lodash_1 = require("lodash");
const helpers_1 = require("../lib/helpers");
function picarto(message_1, _settings_1, _a, type_1) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, { request }, type, channel = message.channel.id) {
        let uri = null;
        if (isNaN(Number(channel))) {
            uri = `https://api.picarto.tv/api/v1/channel/name/${channel}`;
        }
        else {
            uri = `https://api.picarto.tv/api/v1/channel/id/${channel}`;
        }
        if (uri == null) {
            return '[API Error];';
        }
        const req = yield (0, helpers_1.httpRequest)(request, uri);
        if (req == null) {
            return '[Error: API Error]';
        }
        if ((req === null || req === void 0 ? void 0 : req.user_id) === null) {
            return '[Error: Invalid Channel]';
        }
        const value = (0, lodash_1.get)(req, (0, helpers_1.getFromSimple)('picarto', type), '[Type Not Found]');
        if (!(0, helpers_1.isValueValid)(value)) {
            return '[Error: Return Value Invalid]';
        }
        return value;
    });
}
//# sourceMappingURL=picarto.js.map