"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pretzel = pretzel;
const config = require("config");
const helpers_1 = require("../lib/helpers");
const nowPlaying = /Now Playing: (.*) by (.*) -> (.*)/i;
function pretzel(message_1, _settings_1, _a) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, { request }, type = 'all', channelId = message.channel.id, provider = message.provider) {
        const req = yield (0, helpers_1.httpRequest)(request, `${config.get('parser.pretzel.base')}playing/${provider}/${channelId}`);
        if (req === undefined) {
            return '[No Song Playing or Channel Not Found]';
        }
        const playing = nowPlaying.exec(req);
        if (playing == null) {
            return '[Error: API Error]';
        }
        switch (type) {
            case 'song':
                return playing[1];
            case 'artist':
                return playing[2];
            case 'link':
                return playing[3];
            default:
                return `${playing[1]} by ${playing[2]}`;
        }
    });
}
//# sourceMappingURL=pretzel.js.map