"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.randomuser = randomuser;
const lodash_1 = require("lodash");
function randomuser(message, _settings, _context) {
    return __awaiter(this, void 0, void 0, function* () {
        if (message.provider === 'discord') {
            return '<randomuser>';
        }
        const users = yield this.middleware.onHandleMethod('getUsers', message);
        if (users != null && users.length > 0) {
            return (0, lodash_1.chain)(users)
                .shuffle().shuffle().shuffle()
                .sample()
                .valueOf();
        }
        return '[Error: Failed to get users]';
    });
}
//# sourceMappingURL=randomuser.js.map