"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rngphrase = exports.listpick = exports.urldecode = exports.urlencode = exports.incr = exports.randint = exports.echo = exports.query = exports.compile = void 0;
exports.randomnum = randomnum;
exports.add = add;
exports.arg = arg;
exports.randlist = randlist;
exports.math = math;
const lodash_1 = require("lodash");
const mathjs_1 = require("mathjs");
const compile = (_message, _settings, _context, ...str) => str.join('');
exports.compile = compile;
const query = (message, _settings, _ctx, skipIndex = 1) => message.message.args.slice(skipIndex).join(' ');
exports.query = query;
exports.echo = exports.query;
function randomnum(_message, _settings, { cache }, min, max) {
    if (isNaN(Number(min)) || isNaN(Number(max))) {
        return '[Min or Max needs to be a number]';
    }
    if (Number(min) === 0 || Number(max) === 0) {
        return '[Min or Max needs to be more than 0]';
    }
    if (Number(min) > Number(max)) {
        return '[Min should not be more than the Max]';
    }
    const result = (0, lodash_1.random)(Number(min), Number(max));
    cache.push(result);
    return result.toString();
}
exports.randint = randomnum;
function add(_message, _settings, _context, ...numbers) {
    if (numbers == null || numbers.length > 10) {
        return '[Invalid number of arguments]';
    }
    const toHandle = numbers
        .map(n => n.split(','))
        .flat()
        .map(Number)
        .filter((n) => !isNaN(n));
    if (toHandle == null || toHandle.length < 1) {
        return '[No valid numbers to process]';
    }
    return toHandle.reduce((a, b) => a + b);
}
exports.incr = add;
function arg(message, _settings, _context, index) {
    if (isNaN(Number(index))) {
        return '[Index is not a number]';
    }
    const hasArg = message.message.args[Number(index)];
    if (hasArg == null) {
        return '';
    }
    return hasArg;
}
const urlencode = (_message, _settings, _context, ...str) => encodeURIComponent(str.join(' '));
exports.urlencode = urlencode;
const urldecode = (_message, _settings, _context, ...str) => decodeURIComponent(str.join(' '));
exports.urldecode = urldecode;
function randlist(_message_1, _settings_1, _a) {
    return __awaiter(this, arguments, void 0, function* (_message, _settings, { cache }, ...str) {
        if (str == null || str.length < 1) {
            return;
        }
        const list = str.join(' ').split(';');
        if (list == null || list.length < 1) {
            return '';
        }
        const [result] = (0, lodash_1.chain)(list)
            .shuffle()
            .shuffle()
            .sampleSize(1)
            .valueOf();
        cache.push(result);
        return result;
    });
}
exports.listpick = randlist;
exports.rngphrase = randlist;
function math(_message, _settings, _context, ...str) {
    if (str == null || str.length < 1) {
        return;
    }
    const expression = str.join(' ');
    try {
        return (0, mathjs_1.evaluate)(expression);
    }
    catch (e) {
        return '[Error: Invalid Expression]';
    }
}
//# sourceMappingURL=string.js.map