"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tiktok = tiktok;
function tiktok(message, _settings, _context) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield this.middleware.onServiceAPI('https://open.tiktokapis.com/v2/video/list/?fields=id,title,create_time,share_url', {
            coreId: message.channel.coreId,
            method: 'POST',
            serviceId: message.channel.serviceId,
            provider: 'tiktok',
            body: {
                max_count: 5,
            },
        });
        if (res == null) {
            return '[Error: API Error]';
        }
        if (res.data == null || res.data.videos.length === 0) {
            return '[Error: No videos found]';
        }
        return `${res.data.videos[0].title} - ${res.data.videos[0].share_url}`;
    });
}
//# sourceMappingURL=tiktok.js.map