"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.time = time;
const moment = require("moment-timezone");
function time(_message, settings, _context, timezone = settings.timezone, ...args) {
    const formatParts = Array.prototype.slice.call(arguments, 4);
    if (moment.tz.zone(timezone) === null) {
        return '[Error: Invalid Timezone]';
    }
    let format = 'ha z';
    if (formatParts.length > 0) {
        format = formatParts.join(' ');
    }
    return moment.tz(new Date(), timezone)
        .format(format);
}
//# sourceMappingURL=time.js.map