"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.trovo = trovo;
const config = require("config");
const lodash_1 = require("lodash");
const helpers_1 = require("../lib/helpers");
function trovo(message_1, _settings_1, _a, type_1) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, { request }, type, channel = message.channel.id) {
        var _b;
        const reqHeaders = {
            Accept: 'application/json',
            'Client-ID': config.get('providers.trovo.clientId'),
        };
        const reqBody = {};
        if (isNaN(Number(channel))) {
            reqBody['username'] = channel;
        }
        else {
            reqBody['channel_id'] = channel;
        }
        const req = yield (0, helpers_1.httpRequest)(request, `${config.get('providers.trovo.urls.api')}/openplatform/channels/id`, { headers: reqHeaders, method: 'POST', body: JSON.stringify(reqBody) });
        if (req == null) {
            return '[Error: API Error]';
        }
        if (((_b = req === null || req === void 0 ? void 0 : req.data) === null || _b === void 0 ? void 0 : _b.channel) === null) {
            return '[Error: Invalid Channel]';
        }
        const value = (0, lodash_1.get)(req, (0, helpers_1.getFromSimple)('trovo', type), '[Type Not Found]');
        if (!(0, helpers_1.isValueValid)(value)) {
            return '[Error: Return Value Invalid]';
        }
        return value;
    });
}
//# sourceMappingURL=trovo.js.map