"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tweet = void 0;
const config = require("config");
const countdown = require("countdown");
const moment = require("moment");
const helpers_1 = require("../lib/helpers");
const buildQuery = (account) => `from:${account} -is:retweet -is:reply`;
function tweet(_message, _settings, request, account) {
    if (account == null) {
        return '[Error: Account is required]';
    }
    const uri = `${config.get('api.twitter.base')}2/tweets/search/recent?query=${encodeURIComponent(buildQuery(account))}&tweet.fields=created_at`;
    const headers = {
        Authorization: `Bearer ${config.get('api.twitter.key')}`,
    };
    return (0, helpers_1.httpRequest)(request, uri, { headers })
        .then((res) => {
        var _a;
        if (res == null) {
            return '[Error: No response from Twitter]';
        }
        if (((_a = res === null || res === void 0 ? void 0 : res.meta) === null || _a === void 0 ? void 0 : _a.result_count) === 0) {
            return '[Error: User not found]';
        }
        const timeSince = countdown(new Date(), moment(new Date(res.data[0].created_at)).toDate());
        return `${account} - https://twitter.com/${account}/status/${res.data[0].id} | ${timeSince}`;
    })
        .catch(() => {
        return '[Error: No response from Twitter]';
    });
}
exports.tweet = tweet;
//# sourceMappingURL=tweet.js.map