"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.twitch = twitch;
const lodash_1 = require("lodash");
const helpers_1 = require("../lib/helpers");
function twitch(message_1, _settings_1, _context_1, type_1) {
    return __awaiter(this, arguments, void 0, function* (message, _settings, _context, type, channel = message.channel.id) {
        let channelId = channel.toString();
        if (isNaN(Number(channel))) {
            const resTwitchUsr = yield this.middleware.onServiceAPI(`https://api.twitch.tv/helix/users?login=${channel}`, {
                coreId: message.channel.coreId,
                method: 'GET',
                serviceId: message.channel.serviceId,
            });
            if (resTwitchUsr == null) {
                return '[Error: API Error]';
            }
            if (resTwitchUsr.data == null || resTwitchUsr.data.length < 1) {
                return '[Error: Invalid User]';
            }
            channelId = resTwitchUsr.data[0].id;
        }
        const res = yield this.middleware.onServiceAPI(`https://api.twitch.tv/helix/channels?broadcaster_id=${channelId}`, {
            coreId: message.channel.coreId,
            method: 'GET',
            serviceId: message.channel.serviceId,
        });
        if (res == null || res.data.length < 1) {
            return '[Error: API Error]';
        }
        const value = (0, lodash_1.get)(res.data[0], (0, helpers_1.getFromSimple)('twitch', type), '[Type Not Found]');
        if (!(0, helpers_1.isValueValid)(value)) {
            return '[Error: Return Value Invalid]';
        }
        return value;
    });
}
//# sourceMappingURL=twitch.js.map