import { IMessage } from './interface';
import { VarType } from './methods/variable';
interface IReqOpts {
    coreId?: string;
    method: string;
    serviceId?: string;
    provider?: string;
    body?: Object;
}
type MethodType = string;
export interface Middleware {
    onServiceAPI?(uri: string, opts: IReqOpts): Promise<any>;
    onVariableAPI?(coreId: string, varName: string, type: VarType, val: string, reset: boolean): Promise<number>;
    onHandleMethod?(type: MethodType, message: IMessage, args?: object): Promise<any>;
    onGetHeaders?(message: IMessage): Promise<any>;
}
export {};
