"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require("./");
const instance = new _1.Parser();
const message = {
    channel: {
        id: '123',
        name: 'test',
        coreId: '123',
        serviceId: '123',
    },
    provider: 'twitch',
    message: {
        args: ['d2', 'SPS'],
        raw: 'test',
    },
    user: {
        id: '36297622',
        name: 'artdude543',
        roles: ['test'],
    },
};
const setting = {
    timezone: 'America/New_York',
};
function test() {
    return __awaiter(this, void 0, void 0, function* () {
        const INPUT = `{rainwave game}`;
        console.log('Input:', INPUT);
        const res = yield instance.parse(message, setting, INPUT);
        console.log('Output:', res);
    });
}
function testWithOutContext() {
    return __awaiter(this, void 0, void 0, function* () {
        const INPUT = 'Beep can MATH?! {math 10 degC to degF} {user}';
        console.log('Input:', INPUT);
        const res = yield instance.parseWithOutContext(INPUT);
        console.log('Output:', res);
    });
}
function testWithAddingMethods() {
    return __awaiter(this, void 0, void 0, function* () {
        const INPUT = '{test}';
        console.log('Input:', INPUT);
        instance.addMethods({
            name: 'test',
            method: (message, settings, context) => __awaiter(this, void 0, void 0, function* () {
                return 'Hello World!';
            })
        });
        instance.addMethods([
            {
                name: 'test2',
                method: (message, settings, context) => __awaiter(this, void 0, void 0, function* () {
                    return 'Hello World 2!';
                })
            },
            {
                name: 'test3',
                method: (message, settings, context) => __awaiter(this, void 0, void 0, function* () {
                    return 'Hello World 3!';
                })
            }
        ]);
        const res = yield instance.parse(message, setting, INPUT);
        console.log('Output:', res);
        const res2 = yield instance.parse(message, setting, '{test2}');
        console.log('Output:', res2);
        const res3 = yield instance.parse(message, setting, '{test3}');
        console.log('Output:', res3);
    });
}
function testWithAddingMethodAlreadyExist() {
    return __awaiter(this, void 0, void 0, function* () {
        const INPUT = '{test}';
        console.log('Input:', INPUT);
        instance.addMethods({
            name: 'test',
            method: (message, settings, context) => __awaiter(this, void 0, void 0, function* () {
                return 'Hello World!';
            })
        });
        instance.addMethods({
            name: 'test',
            method: (message, settings, context) => __awaiter(this, void 0, void 0, function* () {
                return 'Hello World!';
            })
        });
        const res = yield instance.parse(message, setting, INPUT);
        console.log('Output:', res);
    });
}
testWithAddingMethods();
//# sourceMappingURL=test.js.map